# Описание
Сборка FreeRTOS v9.0.0 для отладочной платы САЛЮТ "ЭЛ24Д1".
Сборка состоит из ядра FreeRTOS, драйверов, сервисов операционной системы, тестов, пользовательских примеров. Проект поставляется вместе с конфигурационными файлами среды разработки NetBeans 8.0.2 с использованием CMake 3.0.2. Проект предназначен для использование из под Linux.
**Подробная документация находится в директории /docs**

# Функционал
* Web сервер
* FTP сервер
* UDP сервис
* SD сервис
* Поддержка файловой системы FAT32

# Быстрый старт
1. Установить toolchain (ftp://ftp.elvees.com/1892VM14YA/FreeRTOS/tools/) 
2. В файле CMakeToolchain.cmake установить значение переменной _CMAKE_TOOLCHAIN_PATH соответствующему пути к toolchain.
3. Собрать инфраструктуру CMake, для этого выполнить ```./start```  в дирректории проекта.
4. Собрать проект, для этого выпольнить ```./build/make``` или собрать проект в среде разработки.
5. Прошить загрузчик в SPI-flash, для этого установить режим загрузки отладочной платы с UART  (BOOT1 - 0. BOOT2 - 1. BOOT3 - 0), выполнить ```sudo –E ./spi-flash-linux.sh path_to_uart [salute_image_version]```. 
   path_to_uart - путь к UART, например /dev/ttyUSB0. 
   salute_image_version - версия загрузчика. Необходимо выбрать образ загрузчика исходя из ревизии отладочной платы. По-умолчанию параметр salute_image_version устанавливется для САЛЮТ "ЭЛ24Д1" Rev 1.5
6. Создать файловую систему на SD карте и прошить образ ОС, для этого подклюить SD карту к компьютеру, выполнить sudo ```./sddisk.sh path_to_sd```. 
   path_to_sd - путь к SD карте, например, /dev/sde.
7. Установить SD карту в отладочную плату, установить режим загрузки на отладочной плате с SPI (BOOT1 - 1. BOOT2 - 1. BOOT3 - 0), подать питание.

| Ревизия отладочной платы | Образ |
| ------ | ------ |
|САЛЮТ "ЭЛ24Д1" Rev 1.3|mcom02-salute-el24d1-r1.3-uboot-v2.3-2017-05-03.img|
|САЛЮТ "ЭЛ24Д1" Rev 1.4|mcom02-salute-el24d1-r1.4-uboot-v2.3-2017-05-03.img|
|САЛЮТ "ЭЛ24Д1" Rev 1.5|mcom02-salute-el24d1-r1.5-uboot-v2.3-2017-05-03.img|


# Структура проекта 
| Файл / Директория | Назначение |
| ------ | ------ |
|/docs|Документация по сборке FreeRTOS|
|/drivers|Драйвера|
|/freertos|Ядро FreeRTOS v9.0.0, дополнительный функционал FreeRTOS|
|/nbproject|Конфигурация среды NetBeans|
|/scripts|Скрипты прошивки SD, SPI, вспомогательные файлы|
|/services|Сервисы операционной системы|
|/tasks|Пользовательские задачи|
|main.c|Файл с точкой входа в main(), основная программа|
|irq_handlers.c|Обработчики системных событий|
|platform.c|Инициалиция платформы|
|reset.s|startup файл|
|mcom2_reg.h|Описание регистров процессора|
|.gdbinit|Файл GDB|
|.gitignore|Файл исключений GIT|
|CMakeLists.txt|Файл CMake с правилами управления проектом|
|CMakeToolchain.cmake|Файл CMake настроек тулчейна|
|start|Скрип создания инфраструктуры CMake|

# Требования
*	Персональный компьютер
*	Операционная система Linux, желательно CentOS7
*	Отладочная плата «Салют-ЭЛ24»
*	PuTTY версии не ниже 0.60
*	USB-UART конвертер
