/*******************************************************************************
*  MCom-02 FreeRTOS port                                                       *
*  Copyright (c) 2017 by RnD Center "ELVEES", JSC                              *
*                                                                              *
*  This file is part of the FreeRTOS distribution.                             *
*                                                                              *
*  FreeRTOS is free software; you can redistribute it and/or modify it under   *
*  the terms of the GNU General Public License (version 2) as published by the *
*  Free Software Foundation >>>> AND MODIFIED BY <<<< the FreeRTOS exception.  *
*******************************************************************************/


#ifndef SDSRV_H_
#define SDSRV_H_

#include <inttypes.h>
#include "../drivers/sd/sd.h"
#include "../freertos/source/FreeRTOS_FAT/ff_headers.h"
#include "../freertos/source/FreeRTOS_FAT/ff_stdio.h"

#define sdsrvSD_SERVICE_STACK_SIZE  (1600)
#define sdsrvWRITE_QUEUE_LEN        (5)
#define sdsrvSD_DISK_NAME           ("/sd")
#define sdsrvSD_DISK_CHACHE_SIZE    (sdSECTOR_SIZE * 2 * 1024 * 1 )  

/**
 * @brief Init service
 */
int vInitSDService( uint8_t ucSDMMC );

/**
 * @brief SD service task
 */
void vSDServiceTask( void *vArg );

/**
 * @brief Write service to queue
 */
SDError_t xSDServiceWrite( sd_card_t *sd, uint32_t startBlock, Block_t *pData, uint32_t numBlocks );

/**
 * @brief Read from service queue
 */
SDError_t xSDServiceRead( sd_card_t *sd, uint32_t startBlock, Block_t *pData, uint32_t numBlocks );

#endif
